﻿using System.IO;
using System.Drawing;
using System.Drawing.Imaging;

class Program
{
    static void Main(string[] args)
    {
        byte[] pixel = new byte[28 * 28];
        Bitmap bitmap = new Bitmap(28, 28);
        // フォルダーを作る
        System.IO.Directory.CreateDirectory(@"bmp_data");
        // ファイルを読み込む
        using (FileStream fsPixel = 
            new FileStream(@"train-images.idx3-ubyte", FileMode.Open))
        {
            using (BinaryReader brPixel = new BinaryReader(fsPixel))
            {
                brPixel.ReadInt32(); // ファイルのヘッダー部分を読み飛ばす
                brPixel.ReadInt32();
                brPixel.ReadInt32();
                brPixel.ReadInt32();
                // ピクセルのデータを読み込んでBMP形式で保存する
                for (int i = 0; i < 60000; i++)
                {
                    for (int j = 0; j < 28 * 28; j++)
                    {
                        pixel[j] = brPixel.ReadByte();
                    }
                    for (int y = 0; y < 28; y++)
                    {
                        for (int x = 0; x < 28; x++)
                        {
                            bitmap.SetPixel(x, y, Color.FromArgb(
                                    (int)pixel[y * 28 + x],
                                    (int)pixel[y * 28 + x],
                                    (int)pixel[y * 28 + x]));
                        }
                    }
                    bitmap.Save(@"bmp_data\image"+i+".bmp", ImageFormat.Bmp);
                    System.Console.WriteLine(@"bmp_data\image"+i+".bmp");
                }
            }
        }
    }
}

